//The meat of the plugin. It's actually pretty simple.

//Makes the player send a hello to the host if they downloaded the plugin.
object_event_add(PlayerControl, ev_create, 0,'		
if(!global.isHost)
    {
        var sendBuffer;
        sendBuffer = buffer_create();
		write_ubyte(sendBuffer, dominations.hello);
        PluginPacketSend(dominations.packetID,sendBuffer,true);
		
    }
')

//Makes the host give all players a dominations map, by which they may track dominations.
object_event_add(Player, ev_create, 0,'		
if(global.isHost)
    {
        killsmap = execute_string(dominations.createMap);
		
		with Player {
			ds_map_add(killsmap,other.id,0);
		}
		
    }
hasDoms = false;
')
//When a player leaves, remove all record of their dominations map and remove them from other players' dominations maps.
object_event_add(Player, ev_destroy, 0,'
/*if global.isHost && variable_local_exists("killsmap"){
	with Player {
        if variable_local_exists("killsmap") ds_map_delete(killsmap,id);
	}
		ds_map_destroy(killsmap);
}*/
ds_list_delete(global.myDoms,ds_list_find_index(global.myDoms,id));
ds_list_delete(global.myNems,ds_list_find_index(global.myNems,id));
')

//Workaround because SOMEONE decided it would be a good idea to make plugins load AFTER the host player has been created.
//Seriously. Change this so I can stop using this stupid shit.
object_event_add(Player, ev_step, ev_step_begin, '
if !variable_local_exists("hasDoms") && global.isHost {
		if id = global.myself {
			hasDoms = true;
		} else {
			hasDoms = false;
		}
    }
	
if (!global.established || !variable_local_exists("killsmap")) && global.isHost {
	killsmap = execute_string(dominations.createMap);
	ds_map_delete(killsmap,id);
	global.established = true;
}
')
object_event_add(RoomChangeObserver,ev_other,ev_room_end,'
if global.isHost {
	if global.established{
		global.established = false;
	}	
}
if global.isHost && variable_local_exists("killsmap"){
	with Player {
        if id != other and variable_local_exists("killsmap") ds_map_delete(killsmap,id);
	}
		ds_map_destroy(killsmap);
}
ds_list_clear(global.myDoms);
ds_list_clear(global.myNems);
')

//When a character dies, update the dominations.
object_event_add(Character, ev_destroy, 0, '
if lastDamageDealer != noone && global.isHost {
	var assistant;
	assistant = secondToLastDamageDealer;
	with lastDamageDealer {
		if object {
			if object.healer {
				assistant = object.healer;
			}
		}	
	}
	
	var sendBuffer, addition, proceed;
	
	proceed = true;
	
	if (lastDamageDealer != noone && player != noone) {
		with (lastDamageDealer) {
			if !variable_local_exists("killsmap") proceed = false;
		}
		if (assistant != noone) {
			with (assistant) {
				if !variable_local_exists("killsmap") proceed = false;
			}
		}
	} else {
		proceed = false;
	}
	
	if !proceed exit;
	
	sendBuffer = buffer_create();
	
	//For the killer player, revenge and then domination.
		if ds_map_find_value(player.killsmap,lastDamageDealer) >= 4
			&& player.team != lastDamageDealer.team
			&& lastDamageDealer != player {
				write_ubyte(sendBuffer,dominations.revenge);
				write_ubyte(sendBuffer,ds_list_find_index(global.players,lastDamageDealer));
				write_ubyte(sendBuffer,ds_list_find_index(global.players,player));
		}
		ds_map_replace(player.killsmap,lastDamageDealer, 0);
			
			addition = ds_map_find_value(lastDamageDealer.killsmap,player);
			addition += 1;
			ds_map_replace(lastDamageDealer.killsmap,player,addition);
		
		if ds_map_find_value(lastDamageDealer.killsmap,player) = 4
			&& player.team != lastDamageDealer.team
			&& lastDamageDealer != player {
				write_ubyte(sendBuffer,dominations.domination);
				write_ubyte(sendBuffer,ds_list_find_index(global.players,lastDamageDealer));
				write_ubyte(sendBuffer,ds_list_find_index(global.players,player));
		}
			
	//For the assistant killer, revenge and then domination--do event and send event for host.
	
	if assistant != noone && instance_exists(assistant) {
		if ds_map_find_value(player.killsmap,assistant) >= 4
			&& player.team != assistant.team
			&& assistant != player {
				write_ubyte(sendBuffer,dominations.revenge);
				write_ubyte(sendBuffer,ds_list_find_index(global.players,assistant));
				write_ubyte(sendBuffer,ds_list_find_index(global.players,player));
		}
		ds_map_replace(player.killsmap,assistant, 0);
			
			addition = ds_map_find_value(assistant.killsmap,player);
			addition += 1;
			ds_map_replace(assistant.killsmap,player,addition);
		
		if ds_map_find_value(assistant.killsmap,player) = 4
			&& player.team != assistant.team
			&& assistant != player {
				write_ubyte(sendBuffer,dominations.domination);
				write_ubyte(sendBuffer,ds_list_find_index(global.players,assistant));
				write_ubyte(sendBuffer,ds_list_find_index(global.players,player));
		}
	}
	
	with Player {
		if hasDoms PluginPacketSendTo(dominations.packetID,sendBuffer,id);
	}
}

');

//Did we receive any messages this step?
//If we did, this script changes the dominations on the client.
object_event_add(PlayerControl, ev_step, ev_step_end,'
    while (PluginPacketGetBuffer(dominations.packetID) != -1) {
		receiveBuffer = PluginPacketGetBuffer(dominations.packetID);
        
		switch(read_ubyte(receiveBuffer)) {
		
			case dominations.hello:
				//We just got a joining player. Make it so they receive further domination info.
				
				if global.isHost {
					var _player;
						_player = PluginPacketGetPlayer(dominations.packetID);
						_player.hasDoms = true;
						
				}	
			break;
			
			case dominations.domination:
			    //Someone has been dominated. Process the packet as the client.
				var dom_killer, dom_victim;
				dom_killer = ds_list_find_value(global.players,read_ubyte(receiveBuffer));
				dom_victim = ds_list_find_value(global.players,read_ubyte(receiveBuffer));
				
				execute_string(dominations.recordDomnLog,dom_victim,dom_killer);
				
				if global.myself == dom_victim {
					sound_play(dominations.DominationSnd);
					ds_list_add(global.myNems,dom_killer);
				}
				if global.myself == dom_killer {	
					ds_list_add(global.myDoms,dom_victim);
					sound_play(dominations.DominationSnd);
				}
			break;
			
			case dominations.revenge:
			    //Someone has had revenge exacted upon them. Process the packet as the client.
				var rev_killer, rev_victim;
				rev_killer = ds_list_find_value(global.players,read_ubyte(receiveBuffer));
				rev_victim = ds_list_find_value(global.players,read_ubyte(receiveBuffer));
				
				execute_string(dominations.recordRevengenLog,rev_victim,rev_killer);
				
				if global.myself == rev_victim {
					sound_play(dominations.RevengeSnd);
					ds_list_delete(global.myDoms,ds_list_find_index(global.myDoms,rev_killer));
				}
				if global.myself == rev_killer {	
					ds_list_delete(global.myNems,ds_list_find_index(global.myNems,rev_victim));
					sound_play(dominations.RevengeSnd);
				}
			break;
		}
        PluginPacketPop(dominations.packetID);
    }
');

//Draw your nemesis. Don't worry. It's not a spyhack.
object_event_add(Character,ev_draw,0,'
var xr, yr;
xr = round(x);
yr = round(y);
var cc, dominatee;
					
if player = global.myself exit;
if global.myself.team != player.team
&& global.myself.team != TEAM_SPECTATOR
&& ds_list_find_index(global.myNems,player) != -1
&& invisible == false {

draw_sprite_ext(NemesisS,player.team,xr,yr-70,1,image_yscale,image_angle,c_white,image_alpha*0.75);

}
')
object_event_add(ScoreTableController,ev_draw,0,'
    var xoffset, yoffset, xsize, ysize, i, player, redteam, blueteam;
    
    xoffset = view_xview[0]+view_wview[0]/2-280;
    yoffset = view_yview[0]+view_hview[0]/2-190;
    xsize = 800/5*3;
    ysize = 600/5*3;
    xcenter = view_xview[0]+view_wview[0]/2; 

    draw_set_alpha(alpha);
    draw_set_color(c_white);
    draw_set_valign(fa_top);
    draw_set_halign(fa_center);
        
    redteam = ds_priority_create();
    blueteam = ds_priority_create();  
    spec = ds_priority_create();
    
    for(i=0; i<ds_list_size(global.players); i+=1)
    {
        player = ds_list_find_value(global.players, i);
        
        if(player.team == TEAM_RED)
            ds_priority_add(redteam, player, player.stats[POINTS]);
        else if (player.team == TEAM_BLUE)
            ds_priority_add(blueteam, player, player.stats[POINTS]);
    }
    
    for(i=0; ds_priority_size(redteam) > 0; i += 1) {
        player = ds_priority_delete_max(redteam);
        
        if (i<12)
        {
            if (global.myself.team != player.team /*&& !global.mapchanging*/) {
                if ds_list_find_index(global.myDoms,player) != -1 {
					draw_sprite_ext(dominations.DomIconS,0,xoffset+14,yoffset+70+20*(i+1),1,1,0,c_white,alpha);
				} else if ds_list_find_index(global.myNems,player) != -1 {
					draw_sprite_ext(dominations.DomIconS,1,xoffset+14,yoffset+70+20*(i+1),1,1,0,c_white,alpha);
				}
            }   
        }
    }
    
    for(i=0; ds_priority_size(blueteam) > 0; i+=1) {
        player = ds_priority_delete_max(blueteam);

        if (i<12)
        {
            if (global.myself.team != player.team /*&& !global.mapchanging*/) {
                if ds_list_find_index(global.myDoms,player) != -1 {
					draw_sprite_ext(dominations.DomIconS,0,xoffset+xsize/2+49,yoffset+70+20*(i+1),1,1,0,c_white,alpha);
				} else if ds_list_find_index(global.myNems,player) != -1 {
					draw_sprite_ext(dominations.DomIconS,1,xoffset+xsize/2+49,yoffset+70+20*(i+1),1,1,0,c_white,alpha);
				}
            }
        }     
    }

    ds_priority_destroy(redteam);
    ds_priority_destroy(blueteam);
')